-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["DEATHKNIGHT"] = {}
local t,t2,s,n
lib.classes["DEATHKNIGHT"][30] = function ()
	lib.SetPower(cfg.Power.type)
	lib.AddRuneSpell("it",{45477},{0,0,1}) -- Icy Touch
	lib.AddRuneSpell("fes",{85948},{1,0,1}) -- Festering Strike
	lib.AddRuneSpell("ss",{55090},{0,1,0}) -- Scourge Strike
	lib.AddRuneSpell("bb",{48721},{1,0,0}) -- Blood Boil
	lib.AddRuneSpell("dt",{63560},{0,1,0}) -- Dark Transformation
	
	lib.AddSpell("uf",{49016}) -- Unholy Frenzy
	lib.AddSpell("garg",{49206}) -- Summon Gargoyle
	
	lib.AddAura("sd",81340,"buff","player") -- Sudden Doom
	lib.AddAura("rc",51460,"buff","player") -- Runic Corruption
	lib.AddAura("si",91342,"buff","pet") -- Shadow Infusion
	lib.AddAura("dt",63560,"buff","pet") -- Dark Transformation
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Outbreak")
	table.insert(cfg.plistdps,"it_ff")
	table.insert(cfg.plistdps,"ps_bp")
	table.insert(cfg.plistdps,"dt")
	table.insert(cfg.plistdps,"dc_high")
	table.insert(cfg.plistdps,"dnd")
	table.insert(cfg.plistdps,"uf")
	table.insert(cfg.plistdps,"garg")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"fes")
	table.insert(cfg.plistdps,"dc_garg")
	table.insert(cfg.plistdps,"Blood Tap")
	table.insert(cfg.plistdps,"erw")
	table.insert(cfg.plistdps,"how")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Outbreak")
	table.insert(cfg.plistaoe,"it_ff")
	table.insert(cfg.plistaoe,"ps_bp")
	table.insert(cfg.plistaoe,"pest")
	table.insert(cfg.plistaoe,"dt")
	table.insert(cfg.plistaoe,"dnd")
--	table.insert(cfg.plistaoe,"fes")
	table.insert(cfg.plistaoe,"bb")
	table.insert(cfg.plistaoe,"ss_aoe")
	table.insert(cfg.plistaoe,"dc")
	table.insert(cfg.plistaoe,"it_aoe")
	table.insert(cfg.plistaoe,"Blood Tap")
	table.insert(cfg.plistaoe,"how")
	table.insert(cfg.plistaoe,"end")
	
	cfg.plist=cfg.plistdps

	cfg.case = {
		["bb"] = function ()
			return lib.RuneCDCheck("bb",true,nil,true)
		end,
		["it_aoe"] = function ()
			return lib.RuneCDCheck("it",nil,nil,true)
		end,
		["dc_garg"] = function ()
			t = lib.GetSpellCD("garg")
			if t>3 then
				return lib.SimpleCDCheck("dc")
			end
			return nil
		end,
		["dt"] = function ()
			t,s = lib.GetAura({"si"})
			if s==5 then
				return lib.RuneCDCheck("dt",true,nil,true,1)
			end
			return nil
		end,
		["dc_high"] = function ()
			t,s = lib.GetAura({"si"})
			if lib.GetAura({"sd"})>0 or cfg.Power.now==cfg.rpmax or (s<5 and lib.GetAura({"dt"})==0) then
				return lib.SimpleCDCheck("dc")
			end
			return nil
		end,
		["uf"] = function ()
			if lib.GetAuras("Speed")<3 then
				return lib.SimpleCDCheck("uf")
			end
			return nil
		end,
		["ss"] = function ()
			return lib.RuneCDCheck("ss",true,nil,true)
		end,
		["ss_aoe"] = function ()
			return lib.RuneCDCheck("ss",nil,nil,true)
		end,
		["fes"] = function ()
			return lib.RuneCDCheck("fes",nil,nil,true)
		end,
		["how"] = function ()
			if lib.GetAura({"sd"})==0 and cfg.Power.now<cfg.spells["dc"].cost then
				return lib.SimpleCDCheck("how")
			end
			return nil
		end,
	}
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	
	lib.rangecheck=function()
		if lib.inrange("ps") then
			lib.bdcolor(Heddmain.bd,nil)
		elseif lib.inrange("it") then
			lib.bdcolor(Heddmain.bd,{0,0,1,1})
		elseif lib.inrange("Outbreak") then
			lib.bdcolor(Heddmain.bd,{0,1,0,1})
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end
	return true
end

lib.classes["DEATHKNIGHT"][2] = function () --Frost
	cfg.talents["Defile"]=IsPlayerSpell(152280)
	--cfg.talents["Necrotic Plague"]=IsPlayerSpell(152281)
	lib.SetPower(cfg.Power.type)
	lib.AddRuneSpell("hb",{49184},{0,0,1}) -- Howling Blast
	lib.AddRuneSpell("Soul Reaper",{130735},{0,0,1},"target") -- Soul Reaper
	lib.AddRuneSpell("ob",{49020},{0,1,1}) -- Obliterate
	lib.AddRuneSpell("pillar",{51271},{0,0,1},true) -- Pillar of Frost
	lib.AddRuneSpell("bb",{48721},{1,0,0}) -- Blood Boil
	
	lib.AddSpell("fs",{49143}) -- Frost Strike
	lib.AddSpell("raise_dead",{46584}) -- Raise Dead
				
	lib.AddAura("rime",59052,"buff","player") -- Freezing Fog
	lib.AddAura("km",51124,"buff","player") -- Killing Machine
	lib.SetTrackAura("km")
	lib.SetAuraFunction("km","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("km","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"pillar")
	table.insert(cfg.plistdps,"ds_proc")
	table.insert(cfg.plistdps,"Safe")
	table.insert(cfg.plistdps,"Death Pact")
	table.insert(cfg.plistdps,"hb_range")
	table.insert(cfg.plistdps,"Plague Leech_2sec")
	table.insert(cfg.plistdps,"Soul Reaper")
	if cfg.equip[17]~=nil then
	--print("DW Frost!")
	cfg.cap=cfg.Power.max-12
	table.insert(cfg.plistdps,"fs_km")
	table.insert(cfg.plistdps,"ob_km")
	--table.insert(cfg.plistdps,"ds_heal")
	if cfg.talents["Defile"] then
		table.insert(cfg.plistdps,"dnd")
	end
	table.insert(cfg.plistdps,"fs_cap")
	table.insert(cfg.plistdps,"bb_dots")
	table.insert(cfg.plistdps,"hb_ff")
	table.insert(cfg.plistdps,"Outbreak")
	table.insert(cfg.plistdps,"ps_bp_unholy")
	table.insert(cfg.plistdps,"ob_unholy")
	table.insert(cfg.plistdps,"hb")
	else
	--print("2hand Frost!")
	cfg.cap=cfg.Power.max-12*2
	if cfg.talents["Defile"] then
		table.insert(cfg.plistdps,"dnd")
	end
	table.insert(cfg.plistdps,"ob_km")
	table.insert(cfg.plistdps,"hb_rime")
	table.insert(cfg.plistdps,"bb_dots")
	table.insert(cfg.plistdps,"hb_ff")
	table.insert(cfg.plistdps,"Outbreak")
	table.insert(cfg.plistdps,"ps_bp_unholy")
	table.insert(cfg.plistdps,"fs_cap")
	table.insert(cfg.plistdps,"ob")
	--table.insert(cfg.plistdps,"fs_km")
	--table.insert(cfg.plistdps,"ds_heal")
	--table.insert(cfg.plistdps,"hb")
	table.insert(cfg.plistdps,"fs")	
	end
	table.insert(cfg.plistdps,"Blood Tap")
	table.insert(cfg.plistdps,"Plague Leech_runes")
	table.insert(cfg.plistdps,"erw")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"HoW")
	table.insert(cfg.plistaoe,"pillar")
	table.insert(cfg.plistaoe,"ds_proc")
	table.insert(cfg.plistaoe,"Plague Leech_2sec")
	--table.insert(cfg.plistaoe,"fs_km")
	--table.insert(cfg.plistaoe,"ob_km")
	table.insert(cfg.plistaoe,"bb_aoe")
	table.insert(cfg.plistaoe,"hb")
	table.insert(cfg.plistaoe,"dnd")
	table.insert(cfg.plistaoe,"bb_dots")
	table.insert(cfg.plistaoe,"Outbreak")
	table.insert(cfg.plistaoe,"ps_bp")
	table.insert(cfg.plistaoe,"Blood Tap")
	table.insert(cfg.plistaoe,"Plague Leech_runes")
	table.insert(cfg.plistaoe,"erw")
	table.insert(cfg.plistaoe,"fs")
	table.insert(cfg.plistaoe,"ps_aoe_2unholy")
	table.insert(cfg.plistaoe,"end")
	cfg.plist=cfg.plistdps
	
	--[[cfg.plistsf = {}
	table.insert(cfg.plistsf,"Outbreak")
	table.insert(cfg.plistsf,"hb_ff")
	table.insert(cfg.plistsf,"ps_bp")
	table.insert(cfg.plistsf,"pillar")
	table.insert(cfg.plistsf,"fs_km")
	table.insert(cfg.plistsf,"hb_aoe")
	table.insert(cfg.plistsf,"fs")
	table.insert(cfg.plistsf,"dnd")
	table.insert(cfg.plistsf,"Blood Tap")
	table.insert(cfg.plistsf,"erw")
	table.insert(cfg.plistsf,"how")
	table.insert(cfg.plistsf,"end")

	if cfg.dk_Shadowfrost then
		cfg.plist=cfg.plistsf
	else
		cfg.plist=cfg.plistdps
	end]]
	
	cfg.case = {
		["hb_ff"] = function()
			return lib.SimpleCDCheck("hb",lib.GetAura({"ff"})-cfg.des_update)
		end,
		["hb_range"] = function()
			if lib.inrange("ob") then return nil end
			return lib.SimpleCDCheck("hb",lib.GetAura({"ff"})-cfg.des_update)
		end,
		["ob_km"] = function ()
			if lib.GetAura({"km"}) > lib.GetSpellCD("ob") then
				return lib.SimpleCDCheck("ob")
			end
			return nil
		end,
		["ob_unholy"] = function ()
			if lib.GetNumRune(2)>0 then
				return lib.SimpleCDCheck("ob",lib.RuneTypeCD(2)) --,true
			else
				return nil
			end
		end,
		["ps_aoe_2unholy"] = function ()
			if lib.GetNumRune(2)>0 then
				return lib.SimpleCDCheck("ps",lib.RuneTypeCD(2,true)) --,true
			else
				return nil
			end
		end,
		["fs_km"] = function ()
			if lib.GetAura({"km"}) > lib.GetSpellCD("fs") then 
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["fs_cap"] = function ()
			if cfg.Power.now>=cfg.cap then 
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
	----
		["tap_frost"]= function()
			if lib.GetRuneCD(1)>lib.GetSpellCD("Blood Tap")+2 or lib.GetRuneCD(2)>lib.GetSpellCD("Blood Tap")+2 then
				return lib.SimpleCDCheck("Blood Tap")
			end
			return nil
		end,
		["hb_ff"] = function()
			return lib.SimpleCDCheck("hb",lib.GetAura({"ff"})-cfg.des_update)
		end,
		["hb_rime"] = function ()
			if lib.GetAura({"rime"})>lib.GetSpellCD("hb") then
				return lib.SimpleCDCheck("hb")
			end
			return nil
		end,
		
		
		["fs_or_dc"] = function ()
			if lib.inrange("fs") then 
				return lib.SimpleCDCheck("fs")
			else
				return lib.SimpleCDCheck("dc")
			end
			return nil
		end,
		
		["ps_aoe"] = function()
			if lib.GetAura({"bp"})<cfg.reapply and lib.inrange("ps") then
				return lib.RuneCDCheck("ps",nil,nil,true)
			end
			return nil
		end,
		["hb_aoe"] = function ()
			if lib.GetAura({"rime"}) > 0 then 
				return lib.SimpleCDCheck("hb")
			end
			return lib.RuneCDCheck("hb",true,nil,true)
		end,
		
--[[		["erw_km"] = function ()
			if lib.GetAura({"km"}) > 0 then
				return cfg.case["erw"]()
			end
			return nil
		end,]]
--[[		["how"] = function ()
			if cfg.Power.now<cfg.spells["fs"].cost then
				return lib.SimpleCDCheck("how")
			end
			return nil
		end,]]
		
	}
	
--[[	cfg.case = {
		["raise_dead"] = function()
			if lib.GetAuras("STR")>0 then
				return lib.SimpleCDCheck("raise_dead")
			end
			return nil
		end,
		["fs_nokm"] = function()
			t = lib.GetAura({"km"})
			if (t>0 and lib.GetRuneSpellCD("ob",true,true)>2) or t==0 then
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["fs_or_dc"] = function ()
			if lib.inrange("fs") then 
				return lib.SimpleCDCheck("fs")
			else
				return lib.SimpleCDCheck("dc")
			end
			return nil
		end,
		["fs_km"] = function ()
			if lib.GetAura({"km"}) > 0 then 
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["fs_cap"] = function ()
			if cfg.Power.now==cfg.rpmax and lib.FullDeplatedRunes()>0 and lib.GetAuras("Speed")==0 then 
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["ps_aoe"] = function()
			if lib.GetAura({"bp"})<cfg.reapply and lib.inrange("ps") then
				return lib.RuneCDCheck("ps",nil,nil,true)
			end
			return nil
		end,
		["hb_aoe"] = function ()
			if lib.GetAura({"rime"}) > 0 then 
				return lib.SimpleCDCheck("hb")
			end
			return lib.RuneCDCheck("hb",true,nil,true)
		end,
		["hb_ff"] = function()
			if lib.GetAura({"ff"})<cfg.reapply then
				return cfg.case["hb_aoe"]()
			end
			return nil
		end,
		["hb_rime"] = function ()
			if lib.GetAura({"rime"})>0 then
				return lib.SimpleCDCheck("hb")
			end
			return nil
		end,
		["hb_norunes"] = function ()
			if (lib.RuneTypeCD(1)+lib.RuneTypeCD(2))==0 and lib.GetAuras("Speed")==0 then
				return lib.RuneCDCheck("hb",true,nil,true)
			end
			return nil
		end,
		["ob_2runes"] = function ()
			if lib.RuneTypeCD(2)==2 or lib.RuneTypeCD(3)==2 then
				return lib.RuneCDCheck("ob",true,nil,true)
			elseif lib.RuneTypeCD(1)==2 then
				return lib.RuneCDCheck("ob",true,nil,true)
			end
			return nil
		end,
		["ob"] = function ()
			if lib.GetAura({"ff"})>0 and lib.GetAura({"bp"})>0 then
				return lib.RuneCDCheck("ob",true,nil,true)
			end
			return nil
		end,
		
		["erw_km"] = function ()
			if lib.GetAura({"km"}) > 0 then
				return cfg.case["erw"]()
			end
			return nil
		end,
		["how"] = function ()
			if cfg.Power.now<cfg.spells["fs"].cost then
				return lib.SimpleCDCheck("how")
			end
			return nil
		end,
		["pillar_aoe"] = function ()
			return lib.RuneCDCheck("pillar",true)
		end,
		["pillar"] = function ()
			if lib.GetAura({"ff"})>0 and lib.GetAura({"bp"})>0 then
				return cfg.case["pillar_aoe"]()
			end
			return nil
		end,
	}]]
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			if cfg.dk_Shadowfrost then
				cfg.plist=cfg.plistsf
			else
				cfg.plist=cfg.plistdps
			end
			cfg.Update=true
		end
		
	end
	
	lib.rangecheck=function()
		if lib.inrange("ob") then
			lib.bdcolor(Heddmain.bd,nil)
		elseif lib.inrange("hb") then
			lib.bdcolor(Heddmain.bd,{0,0,1,1})
		elseif lib.inrange("Outbreak") then
			lib.bdcolor(Heddmain.bd,{0,1,0,1})
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end
	
	return true
end

lib.classes["DEATHKNIGHT"][1] = function () --Blood
	lib.SetPower(cfg.Power.type)
	cfg.cap=cfg.Power.max-12
	lib.AddRuneSpell("it",{45477},{0,0,1}) -- Icy Touch
	lib.AddRuneSpell("Soul Reaper",{114866},{1,0,0},"target") -- Soul Reaper
	
	lib.AddSpell("rs",{56815}) -- Rune Strike
	
	lib.AddAura("cs",81141,"buff","player") -- Crimson Scourge
	lib.SetTrackAura("cs")
	lib.SetAuraFunction("cs","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("cs","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
	lib.AddSpell("Bone Shield",{49222},true)
	lib.AddSpell("Vampiric Blood",{55233},true)
	
	lib.AddSpell("Rune Tap",{48982})
	lib.AddAura("Rune Tap",171049,"buff","player")
	lib.AddAura("Resolve",158300,"buff","player")
	--[[lib.SetAuraFunction("Resolve","OnValue1",function()
		print(cfg.aura["Resolve"].value1)
	end)]]
	
	lib.AddSpell("drw",{49028})
	
	lib.AddAura("drw",81256,"buff","player")
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"Vampiric Blood")
	table.insert(cfg.plistdps,"Safe")
	table.insert(cfg.plistdps,"ds_VB")
	table.insert(cfg.plistdps,"dnd")
	table.insert(cfg.plistdps,"drw")
	table.insert(cfg.plistdps,"dc_cap")
	table.insert(cfg.plistdps,"bb_dots")
	table.insert(cfg.plistdps,"bb_dots_longer")
	table.insert(cfg.plistdps,"Outbreak")	
	table.insert(cfg.plistdps,"it_ff_range")
	table.insert(cfg.plistdps,"ps_bp")
	table.insert(cfg.plistdps,"it_ff")
	table.insert(cfg.plistdps,"Soul Reaper")
	table.insert(cfg.plistdps,"ds")
	table.insert(cfg.plistdps,"Death Pact")
	table.insert(cfg.plistdps,"bb_cs")
	table.insert(cfg.plistdps,"bb_blood")
	table.insert(cfg.plistdps,"dc")
	table.insert(cfg.plistdps,"Blood Tap")
	table.insert(cfg.plistdps,"Plague Leech_runes")
	table.insert(cfg.plistdps,"erw")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"HoW")
	table.insert(cfg.plistaoe,"Vampiric Blood")
	table.insert(cfg.plistaoe,"Safe")
	table.insert(cfg.plistaoe,"dnd")
	table.insert(cfg.plistaoe,"bb_dots")
	table.insert(cfg.plistaoe,"Outbreak")
	table.insert(cfg.plistaoe,"it_ff_range")
	table.insert(cfg.plistaoe,"ps_bp")
	table.insert(cfg.plistaoe,"it_ff")
	table.insert(cfg.plistaoe,"ds_heal")
	table.insert(cfg.plistaoe,"bb")
	table.insert(cfg.plistaoe,"ds_aoe")
	table.insert(cfg.plistaoe,"Death Pact")
	table.insert(cfg.plistaoe,"dc")
	table.insert(cfg.plistaoe,"Blood Tap")
	table.insert(cfg.plistaoe,"Plague Leech_runes")
	table.insert(cfg.plistaoe,"erw")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps
	
	cfg.case = {
		["Vampiric Blood"] = function ()
			if lib.GetUnitHealth("player","percent")<=cfg.heal and lib.GetSpellCD("Vampiric Blood")+1>=lib.GetSpellCD("ds") then
				return lib.SimpleCDCheck("Vampiric Blood")
			end
			return nil
		end,
		["Bone Shield"] = function ()
			if lib.GetUnitHealth("player","percent")<=cfg.heal then
				return lib.SimpleCDCheck("Bone Shield",lib.GetAura({"Bone Shield"}))
			end
			return nil
		end,
		["bb_blood"] = function ()
			return lib.SimpleCDCheck("bb",lib.RuneTypeCD(1))
		end,
		["ds_aoe"] = function ()
			return lib.SimpleCDCheck("ds",max(lib.RuneTypeCD(2),lib.RuneTypeCD(3)))
		end,
		["ds_VB"] = function ()
			if lib.GetUnitHealth("player","percent")<=cfg.heal and lib.GetAura({"Vampiric Blood"})>=lib.GetSpellCD("ds") then
				return lib.SimpleCDCheck("ds")
			end
			return nil
		end,
		["bb_cs"] = function ()
			if lib.GetAura({"cs"})>lib.GetSpellCD("bb") then
				return lib.SimpleCDCheck("bb")
			end
			return nil
		end,
		["dc_cap"] = function ()
			if cfg.Power.now>=cfg.cap then 
				return lib.SimpleCDCheck("dc")
			end
			return nil
		end,
		
		["how"] = function ()
			if cfg.Power.now<cfg.spells["rs"].cost then
				return lib.SimpleCDCheck("how")
			end
			return nil
		end,
	}

	cfg.mode = "dps"
	
--[[	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "def"
			cfg.plist=cfg.plistdef
			cfg.Update=true
		elseif cfg.mode == "def" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end]]
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end
	
	lib.rangecheck=function()
		if lib.inrange("ds") then
			lib.bdcolor(Heddmain.bd,nil)
		elseif lib.inrange("it") then
			lib.bdcolor(Heddmain.bd,{0,0,1,1})
		elseif lib.inrange("dc") then
			lib.bdcolor(Heddmain.bd,{0,1,0,1})
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end

	return true
end

lib.classevents["DEATHKNIGHT"] = function()
	cfg.heal=85
	cfg.talents["Improved Soul Reaper_Perk"]=IsPlayerSpell(157342)
	cfg.talents["Defile"]=IsPlayerSpell(152280)
	cfg.talents["Necrotic Plague"]=IsPlayerSpell(152281)
	if cfg.talents["Necrotic Plague"] then
		cfg.des_update=0
	else
		cfg.des_update=9
	end
	
	lib.SetPower(cfg.Power.type)
	lib.HideCombo()
	lib.AddResource(cfg.Power.max,cfg.cap)
	lib.SetTypeResource(cfg.Power.type)
	lib.SetInterrupt("Kick",{47528})
	
	lib.AddSpell("Outbreak",{77575}) -- Outbreak

	lib.AddRuneSpell("ps",{45462},{0,1,0}) -- Plague Strike
	lib.AddAura("bp",55078,"debuff","target") -- Blood Plague
	lib.AddAura("ff",55095,"debuff","target") -- Frost Fever
	if cfg.talents["Necrotic Plague"] then
		lib.AddAura("bp",155159,"debuff","target")
		lib.AddAura("ff",155159,"debuff","target")
	end
	
	lib.SetTrackDOT("bp")
	
	lib.AddSpell("dc",{47541}) -- Death Coil
	
	lib.AddSpell("erw",{47568}) -- Empower Rune Weapon
	cfg.case["erw"] = function()
		return lib.SimpleCDCheck("erw",lib.GetSpellCD("gcd",true))
	end
	lib.AddRuneSpell("dnd",{43265},{0,1,0}) -- Death and Decay
	lib.ChangeSpellId("dnd",152280,cfg.talents["Defile"])
	
	
	lib.AddSpell("Plague Leech",{123693}) -- Plague Leech
	cfg.case["Plague Leech_runes"] = function()
		if lib.GetSpellCD("Plague Leech")<math.min(lib.GetAura({"ff"}),lib.GetAura({"bp"}))-2 and lib.GetDepletedRune(1)+lib.GetDepletedRune(2)+lib.GetDepletedRune(3)+lib.GetDepletedRune(4)>=2 then
			return lib.SimpleCDCheck("Plague Leech")
		end
		return nil
	end
	cfg.case["Plague Leech_2sec"] = function()
		if lib.GetSpellCD("Plague Leech")<math.min(lib.GetAura({"ff"}),lib.GetAura({"bp"}))-2 then
			return lib.SimpleCDCheck("Plague Leech",math.min(lib.GetAura({"ff"}),lib.GetAura({"bp"}))-2)
		end
		return nil
	end
	if cfg.talenttree==2 then
		cfg.gcd = "fs"
	else
		cfg.gcd = "dc"
	end
	
	cfg.destime=21
	cfg.rpmax=100
	
	lib.AddRuneSpell("ds",{49998},{0,1,1}) -- Death Strike
	lib.AddAura("ds",101568,"buff","player") -- ds
	cfg.case["ds_proc"] = function()
		if lib.GetSpellCD("ds")<lib.GetAura({"ds"}) and lib.GetUnitHealth("player","percent")<=cfg.heal then
			return lib.SimpleCDCheck("ds")
		end
		return nil
	end
	
	cfg.case["ds_heal"] = function()
		if lib.GetUnitHealth("player","percent")<=cfg.heal then
			return lib.SimpleCDCheck("ds")
		end
		return nil
	end
	
	lib.AddSpell("Blood Tap",{45529}) -- Tap
	lib.AddAura("Blood Tap_stacks",114851,"buff","player")
	cfg.case["Blood Tap"] = function()
		if lib.GetAuraStacks("Blood Tap_stacks")>=5 and lib.GetDepletedRune(1)+lib.GetDepletedRune(2)+lib.GetDepletedRune(3)+lib.GetDepletedRune(4)>=3 then
			return lib.SimpleCDCheck("Blood Tap",lib.GetSpellCD("gcd",true))
		end
		return nil
	end
	
	if cfg.hiderunes then lib.hideRuneFrame() end
	
	function Heddclassevents.PLAYER_UNGHOST()
		if lib.UpdateAllRunes() then
			lib.UpdateAllSpells("rune")
			cfg.Update=true
		end
	end
	
	function Heddclassevents.RUNE_POWER_UPDATE(rune)
		if rune and rune>=1 and rune<=6 then
			if lib.UpdateRune(rune) then
				lib.UpdateAllSpells("rune")
				cfg.Update=true
			end
		end
	end
	
	
	Heddclassevents.RUNE_TYPE_UPDATE=Heddclassevents.RUNE_POWER_UPDATE
	--[[function Heddclassevents.RUNE_TYPE_UPDATE(rune)
		if rune and rune>0 and rune<6 then
			if lib.UpdateRune(rune) then
				lib.UpdateAllSpells("rune")
				cfg.Update=true
			end
		end
	end]]
	
	cfg.lastpest=0
	--[[function Heddevents:UNIT_SPELLCAST_SUCCEEDED(unit,spell)
		if unit=="player" then
			if spell==cfg.spells["pest"].name and lib.GetAura({"ff"})>0 and lib.GetAura({"bp"})>0 then
				cfg.lastpest=GetTime()
				cfg.Update=true]]
--[[			else
				for _, i in pairs({"Outbreak","ps","hb","it"}) do
					if cfg.spells[i] and spell==cfg.spells[i].name then
						cfg.lastpest=0
						cfg.Update=true
					end
				end]]
	--[[		end
		end
	end]]
	
	cfg.destime=30*1.3
	cfg.rpmax=100
	--[[lib.mytal = function()
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(3,3)
		cfg.destime = (21+4*currRank)
		nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(2,1)
		cfg.rpmax = (100+10*currRank)
	end]]
	
	cfg.case["ps_bp"] = function()
		return lib.SimpleCDCheck("ps",lib.GetAura({"bp"})-cfg.des_update)
	end
	
	cfg.case["ps_bp_unholy"] = function()
		if lib.GetNumRune(2)>0 then
			return lib.SimpleCDCheck("ps",math.max(lib.RuneTypeCD(2),lib.GetAura({"bp"})-cfg.des_update))
		else
			return nil
		end
	end
	
	lib.AddRuneSpell("bb",{50842},{1,0,0}) -- Blood Boil
	if not cfg.talents["Necrotic Plague"] then
		cfg.case["bb_dots"] = function()
			if cfg.TrackDOT.num>0 and lib.GetAura({"bp"})==0 then
				return lib.SimpleCDCheck("bb")
			end
			return nil
		end
		cfg.case["bb_aoe"] = function()
			if cfg.TrackDOT.num>0 and cfg.TrackDOT.num<2 then
				return lib.SimpleCDCheck("bb")
			end
			return nil
		end
		cfg.case["bb_dots_longer"] = function ()
			if lib.GetAura({"bp"})>lib.GetSpellCD("bb") and lib.GetAura({"ff"})>lib.GetSpellCD("bb") then
				return lib.SimpleCDCheck("bb",lib.GetAura({"bp","ff"},"min")-cfg.des_update)
			end
			return nil
		end
	end
	
	
	cfg.case["it_ff"] = function()
		return lib.SimpleCDCheck("it",lib.GetAura({"ff"})-cfg.des_update)
	end
	
	cfg.case["it_ff_range"] = function()
		if lib.inrange("ds") then return nil end
		return lib.SimpleCDCheck("it",lib.GetAura({"ff"})-cfg.des_update)
	end
		
	cfg.case["Outbreak"] = function()
		return lib.SimpleCDCheck("Outbreak",lib.GetAura({"bp","ff"},"min"))
	end

	lib.AddSpell("Icebound Fortitude",{48792},true)
	lib.AddSpell("Anti-Magic Shell",{48707},true)
	
	
	lib.AddSpell("HoW",{57330}) -- Horn of Winter
	cfg.case["HoW"] = function()
		return lib.SimpleCDCheck("HoW",lib.GetAuras("Attack_Power"))
	end
	
	if cfg.talents["Improved Soul Reaper_Perk"] then
		cfg.reaper=45
	else
		cfg.reaper=35
	end
	
	cfg.case["Soul Reaper"] = function()
		if lib.GetUnitHealth("target","percent")>cfg.reaper or lib.GetTargetLVL()<2 then return nil end
		return lib.SimpleCDCheck("Soul Reaper")
	end

	lib.AddSpell("Death Pact",{48743},"player")
	cfg.case["Death Pact"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 then
			return lib.SimpleCDCheck("Death Pact") --,lib.GetAura({"Vampiric Blood"})
		end
		return nil
	end
	
	lib.AddAurasAlias("DK_saves",{"Bone Shield","Icebound Fortitude","Rune Tap"})
	cfg.case["Safe"] = function ()
		if lib.GetUnitHealth("player","percent")<=cfg.heal then
			return lib.SimpleCDCheck(lib.GetSpellShortestCD({"Bone Shield","Icebound Fortitude","Rune Tap"}),lib.GetAuras("DK_saves"))
		end
		return nil
	end

	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("ds")
		lib.CDadd("pillar")
		lib.CDadd("Soul Reaper")
		lib.CDadd("dnd")
		lib.CDadd("drw")
		lib.CDadd("erw")
		lib.CDadd("Plague Leech")
		lib.CDadd("Blood Tap",nil,true)
		lib.CDadd("Death Pact") --,nil,nil,"turnoff"
		lib.CDadd("Vampiric Blood")
		lib.CDadd("Bone Shield")
		lib.CDadd("Icebound Fortitude")
		lib.CDadd("Rune Tap")
		lib.CDadd("Anti-Magic Shell",nil,nil,"turnoff")
		
	end
	lib.AddRunesFrame()
	cfg.onpower=true
end